//+------------------------------------------------------------------+
//| PivotP Daily.mq4 |
//| Plot Pivot Points |
//| |
//+------------------------------------------------------------------+

#property copyright "2005"

#property indicator_chart_window
#property indicator_buffers 7

#property indicator_color6 Red // R3..R2
#property indicator_color4 Red // R2..R1
#property indicator_color2 Red // R1..Pivot

#property indicator_color1 Yellow // Pivot

#property indicator_color3 DodgerBlue // S1..Pivot
#property indicator_color5 DodgerBlue // S2..S1
#property indicator_color7 DodgerBlue // S3..S2

#define width 1

datetime BT[];
double YesterdayHigh[50];
double YesterdayLow[50];
double YesterdayClose[50];
double YesterdayOpen[50];

double PivotArray[];
double R1Array[];
double S1Array[];
double R2Array[];
double S2Array[];
double R3Array[];
double S3Array[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function |
//+------------------------------------------------------------------+
int init()
{
//---- indicators
// Pivot
SetIndexStyle(0,DRAW_LINE,STYLE_SOLID,width);
SetIndexBuffer(0,PivotArray);
IndicatorShortName("Pivot_a");
SetIndexLabel(0,"Pivot");

// Resistance 1
SetIndexStyle(1,DRAW_LINE,STYLE_DOT,width);
SetIndexBuffer(1,R1Array);
SetIndexLabel(1,"R1");

// Support 1
SetIndexStyle(2,DRAW_LINE,STYLE_DOT,width);
SetIndexBuffer(2,S1Array);
SetIndexLabel(2,"S1");

// Resistance 2
SetIndexStyle(3,DRAW_LINE,STYLE_DOT,width);
SetIndexBuffer(3,R2Array);
SetIndexLabel(3,"R2");

// Support 2
SetIndexStyle(4,DRAW_LINE,STYLE_DOT,width);
SetIndexBuffer(4,S2Array);
SetIndexLabel(4,"S2");

// Resistance 3
SetIndexStyle(5,DRAW_LINE,STYLE_DOT,width);
SetIndexBuffer(5,R3Array);
SetIndexLabel(5,"R3");

// Support 3
SetIndexStyle(6,DRAW_LINE,STYLE_DOT,width);
SetIndexBuffer(6,S3Array);
SetIndexLabel(6,"S3");

return(0);
}
//+------------------------------------------------------------------+
//| Custor indicator deinitialization function |
//+------------------------------------------------------------------+
int deinit()
{

return(0);
}
//+------------------------------------------------------------------+
//| Custom indicator iteration function |
//+------------------------------------------------------------------+
int start()
{
int counted_bars=IndicatorCounted();

ArrayCopySeries(BT, MODE_TIME);
ArrayCopySeries(YesterdayHigh, MODE_HIGH, Symbol(), PERIOD_D1);
ArrayCopySeries(YesterdayLow, MODE_LOW, Symbol(), PERIOD_D1);
ArrayCopySeries(YesterdayClose, MODE_CLOSE, Symbol(), PERIOD_D1);

int od = 0;
int dd = 0;

double Pivot;
double R1;
double S1;
double R2;
double S2;
double R3;
double S3;
double Range;

for (int i = 0; i <= Bars; i++) 
{
if (TimeDay(BT[i]) != od) 
{
dd++;
Pivot = (YesterdayHigh[dd] + YesterdayLow[dd] + YesterdayClose[dd])/3;

Range = YesterdayHigh[dd] - YesterdayLow[dd];
R1 = (2*Pivot)-YesterdayLow[dd];
S1 = (2*Pivot)-YesterdayHigh[dd];
R2 = Pivot-S1+R1;
S2 = Pivot-R1+S1;
R3 = Pivot+2*Range;
S3 = Pivot-2*Range;

od = TimeDay(BT[i]);
}

PivotArray[i] = Pivot;
R1Array[i]=(R1+Pivot)/2;
S1Array[i]=(S1+Pivot)/2;
R2Array[i]=(R2+R1)/2;
S2Array[i]=(S2+S1)/2;
R3Array[i]=(R3+R2)/2;
S3Array[i]=(S3+S2)/2;
}

return(0);
}
//+------------------------------------------------------------------+